#include <htc.h>
#include "Fcpu.h"
#include "LCD_HD44780_4bit.h"

void Strobe(void)
{
	EN = 1;
	__delay_us(100);
	EN = 0;
	__delay_us(100);
}

//Pkaz
void Lcd_Cmd(unsigned char Cmd)
{	
 LCD_PORT = (Cmd & 0xF0);	             	 
 RS = 0;					//RS = 0(pkaz)
 Strobe();

 LCD_PORT = (Cmd & 0x0F)<<4;	             	
 RS = 0; 					//RS = 0(pkaz)	
 Strobe();

/*
Pokud je vsledek v podmnce nula, jedn se o 
pkaz "Vyma dislej" nebo "Nvrat na zatek", kter
vyaduj del interval
*/
 if (Cmd & 0b11111100) __delay_us(100);else __delay_ms(2);
} 

//Data
void Lcd_Chr(unsigned char Chr)
{
 LCD_PORT = (Chr & 0xF0);
 RS = 1;				//RS = 1(data)
 Strobe();

 LCD_PORT = (Chr & 0x0F)<<4;	               
 RS = 1; 				//RS = 1(data)	
 Strobe();
}

//inicializace LCD
void Lcd_Init(void)
{
 __delay_ms(40);	         //ekej > 15ms

//Nastaven PORTu na vstup	
 LCD_TRIS = 0b00000011;
 
//zapi 03h 8bitov komunikace
 LCD_PORT = 0b00110000; 	
 Strobe();			      
 __delay_ms(5);	              //ekej > 4,1ms

//zapi 03h 8bitov komunikace 
 Strobe();
			  
//zapi 03h 8bitov komunikace                      
 Strobe();
 
//4bitov komunikace
 LCD_PORT = 0b00101011; 
 Strobe();

 Lcd_Cmd(0b00101000);		  //dva dky
 Lcd_Cmd(0b00000001);		  //sma LCD
 Lcd_Cmd(0b00001100);		  //zapni LCD
 Lcd_Cmd(0b00000110);		  //incrementace
}

//etzec
void Lcd_Out(const char *str)
{
	unsigned char x = 0;
	while(str[x]!=0)
  	{
		__delay_us(100);
		Lcd_Chr(str[x]);
		x++;
  	}
}

//Nastaven ukazatele na pozici x,y
void Lcd_Gotoxy(unsigned char row,unsigned char col)
{
  switch(row)
  {
   case 1:row=0x00;break;
   case 2:row=0x40;break;
  }	
  Lcd_Cmd(0b10000000 | row | col);
}
