/* 
 * File:   main.c
 * Author: Standa
 *
 * Teplomr s DS18B20 a PIC16F887,8MHz extern krystal
 *
 * vstup na LCD(HD44780):
 * LCD_D4..D7 - PD4..PD7
 * LCD_EN - PD3
 * LCD_RS - PD2
 *
 * DS18B20 - PB3
 *
 * Created on 13. nor 2013, 10:07
 */

#include <htc.h>
#include "Fcpu.h"                   //kmitoet Fcpu

__CONFIG(FOSC_HS & WDTE_ON & MCLRE_ON & CP_OFF & PWRTE_ON & BOREN_ON);

#include "LCD_HD44780_4bit.h"
#include "One_wire.h"

unsigned char cidlo = 0;
unsigned int teplota = 0;
unsigned int temp = 0;
unsigned char teplota_msb, teplota_lsb;

void main(void)
{
    __delay_ms(500);                //prodleva po startu ped pouitm PORTB
    
    ANSELH = 0x00;                  //RB0..RB5 nastaveny na digitln I/O
    
    Lcd_Init();

    Lcd_Out("Teplomer s ");
    Lcd_Gotoxy(2,0);
    Lcd_Out("DS18B20");
    __delay_ms(1500);
    Lcd_Cmd(LCD_CLR);

    while(1)
    {
        Ow_Reset();
        Ow_Write(SKIP_ROM);         //Pesko ten ROM
        Ow_Write(CONVERT_T);        //Zahjen pevodu teploty

        __delay_ms(800);            //as pevodu

        cidlo = Ow_Reset();
        Ow_Write(SKIP_ROM);         //Pesko ten ROM
        Ow_Write(READ_SCRATCHPAD);  //ten teploty ze scratchpadu

//Naten obsahu scratchpadu DS18B20
        teplota_lsb = Ow_Read();
        teplota_msb = Ow_Read();
        teplota = ((int)(teplota_msb<<8))|teplota_lsb;
//--------------------------------------------------------
        Lcd_Cmd(LCD_HOME);                  //vpis od zatku LCD
        Lcd_Out("Temp: ");
        Lcd_Gotoxy(1,6);

        if(cidlo == 1)                      //Pokrauj pokud idlo pipojeno
        {
            if(teplota&0x8000)              //teplota < 0
            {
                temp = (~teplota + 1)>>4;
                Lcd_Chr(45);                //zobrazen "-"
            }
            else                            //teplota >= 0
            {
                temp = (teplota >> 4);
                if(temp/100) Lcd_Chr((temp/100) + 48); else Lcd_Chr(32);
            }

            Lcd_Chr(((temp%100)/10) + 48);
            Lcd_Chr(((temp%100)%10) + 48);
            Lcd_Chr(',');

            //Vpoet desetin a setin stupn-------------------------------------------
            if(teplota & 0x8000) temp = ((~teplota + 1)& 0x000F)*625;
            else temp = (teplota&0x000F)*625;
            Lcd_Chr(temp/1000 + 48);        //vpoet desetin
            Lcd_Chr((temp/100)%10 + 48);    //vpoet setin
            Lcd_Chr(0xDF);                  //
            Lcd_Chr('C');                   //Zobrazen C
        }
        else
        {
            Lcd_Gotoxy(1,6);
            Lcd_Out("Error");               //idlo nepipojeno
        }
    }
}

